<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

if(!defined('VALID_CMS'))die('ACCESS DENIED');

class p_imperavi_redactor extends cmsPlugin {
    
    public static $one_time = false;

// ========================================================================== //

    public function __construct(){
        
        parent::__construct();

        $this->info['plugin']           = 'p_imperavi_redactor';
        $this->info['title']            = 'Imperavi Redactor';
        $this->info['description']      = 'Визуальный редактор <a href="http://imperavi.com/redactor/" target="_blank">Imperavi Redactor</a>';
        $this->info['author']           = '<a href="http://www.instantcms.ru/users/lokanaft#upr_p_services">lokanaft</a>';
        $this->info['version']          = '0.2b';
        $this->info['type']             = 'wysiwyg';

        $this->events[]                 = 'INSERT_WYSIWYG';
        $this->events[]                 = 'GET_ROUTE_CONTENT';//mb_strtoupper(cmsConfig::getConfig('com_without_name_in_url'))
        $this->events[]                 = 'GET_CONTENT_ACTION_IMPERAVI_PHOTO_UPLOADER';
        $this->events[]                 = 'GET_CONTENT_ACTION_IMPERAVI_PHOTO_JSON';

        $this->config['Enable photo upload for groups'] = '2,7';
        $this->config['Max img width']          = 600;
        $this->config['Max img height']         = 600;
        $this->config['Add watermark']          = '0';
        $this->config['Show uploaded photos']   = '1';
        $this->config['Convert video links']    = '1';
        $this->config['Autoresize textarea']    = '1';
        $this->config['Convert divs to p']      = '0';
        $this->config['P clips']                = '1';
        $this->config['P fontfamily']           = '1';
        $this->config['P fontsize']             = '1';
        $this->config['P fullscreen']           = '1';
        $this->config['P textdirection']        = '1';
        $this->config['P fontcolor']            = '1';

    }
    
// ========================================================================== //
    
    public function install(){
        
        $this->inDB->query('CREATE TABLE IF NOT EXISTS `cms_plugin_imperavi_photos` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `pubdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                `user_id` int(11) NOT NULL,
                                `i_comp` varchar(50) NOT NULL,
                                `i_do` varchar(50) NOT NULL,
                                `i_id` int(11) NOT NULL,
                                `i_file` varchar(150) NOT NULL,
                                PRIMARY KEY (`id`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=utf8;');
        
        return parent::install();
    }

// ========================================================================== //

    public function execute($event, $data){

        parent::execute();
        
        switch ($event){
            case 'INSERT_WYSIWYG': return $this->getRedactor($data);
            case 'GET_ROUTE_CONTENT': return $this->getRoute($data);
            case 'GET_CONTENT_ACTION_IMPERAVI_PHOTO_UPLOADER': return $this->uploadPhoto();
            case 'GET_CONTENT_ACTION_IMPERAVI_PHOTO_JSON': return $this->getJSON();
        }
        
        return $data;
        
    }
    
// ========================================================================== //
    
    private function getRedactor($item){
        
        $s = '';
        if(!self::$one_time){//инициализация происходит один раз для всех форм на странице
            
            global $_LANG;
            
            $this->addHeadCSS('plugins/p_imperavi_redactor/redactor/redactor.css');
            $this->addHeadJS('plugins/p_imperavi_redactor/redactor/redactor.js');
            
            $options = array();

            //плагины
            $plugins = array(
                'clips',
                'fontfamily',
                'fontsize',
                'fullscreen',
                'textdirection',
                'fontcolor'
            );
            
            foreach($plugins as $plugin){
                if(!$this->config['P '.$plugin])continue;
                $options['plugins'][] = $plugin;
                $this->addHeadJS('plugins/p_imperavi_redactor/redactor/plugins/'.$plugin.'/'.$plugin.'.js');
            }
            //о ужас (clips)
            if($this->config['P clips']){
                $this->addHeadCSS('plugins/p_imperavi_redactor/redactor/plugins/clips/clips.css');
                $clips = array();
                //тут значит эти самые готовые коды нужно перечислить
                $clips['Lorem ipsum …'] = 'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.';
                $clips['Red label'] = '<span class="label-red">Label</span>';
                $s .= '<div id="clipsmodal" style="display: none;">
                            <section>
                                    <ul class="redactor_clips_box">';

                foreach ($clips as $cname => $clip) {
                    $s .= '<li><a href="#" class="redactor_clip_link">'.$cname.'</a><div class="redactor_clip" style="display:none">'.$clip.'</div></li>';
                }

                $s .= '             </ul>
                            </section>
                            <footer>
                                    <a href="#" class="redactor_modal_btn redactor_btn_modal_close">'.$_LANG['CLOSE'].'</a>
                            </footer>
                    </div>';
            }

            //файл языка
            if(cmsConfig::getConfig('lang') !== 'en'){
                $this->addHeadJS('plugins/p_imperavi_redactor/redactor/lang/'.cmsConfig::getConfig('lang').'.js');
                $options['lang'] = cmsConfig::getConfig('lang');
            }

            //конвертирование ссылок vimeo и youtube
            $options['convertVideoLinks'] = $this->config['Convert video links'] ? true : false;
            
            //авторесайз поля вводя
            $options['autoresize'] = $this->config['Autoresize textarea'] ? true : false;
            
            //отмена конвертирования дивов в параграфы
            $options['convertDivs'] = $this->config['Convert divs to p'] ? true : false;
            
            if($this->canUpload()){
                
                $id = cmsCore::request('id', 'int', 0);
                
                $tail = '?imperavi=1&i_comp='.$this->inCore->component.'&i_do='.$this->inCore->do.'&i_id='.$id;
                
                //вставка из буфера обмена
                $options['clipboardUploadUrl'] = '/_imperavi_photo_uploader_'.$tail;

                //заливка картинок перетаскиванием
                $options['imageUpload'] = '/_imperavi_photo_uploader_'.$tail;
                
                //загруженые фотки
                if($this->config['Show uploaded photos'] && $id)$options['imageGetJson'] = '/_imperavi_photo_json_'.$tail;
            }

            $s .= '<style>textarea.imperavi_redactor{background:none}</style>';
            $s .= '<script type="text/javascript">(function($){$(document).ready(function(){';
            if(defined('VALID_CMS_ADMIN'))//эта чушь (костыль) для работы "упрощателей" только для админки
                $s .= '             FCK_EDITMODE_WYSIWYG = true;
                                    FCKeditorAPI = {
                                        selector: null,
                                        EditMode: true,
                                        GetInstance: function(selector) {
                                            this.selector = $("textarea[name=\'"+selector+"\']");
                                            return this;},
                                        InsertHtml: function(text) {
                                            $("textarea[name=\'content\']").redactor("insertHtml", text);
                                        }
                                    };';
            $s .= '$(".imperavi_redactor").redactor('.json_encode($options).');
                    })})(jQuery)</script>';
            self::$one_time = true;
        }
        
        if($item['text']){
            preg_match_all('~src="(/[-\w/\.]+)"~uis', $item['text'], $matches, PREG_SET_ORDER);
            foreach($matches as $match){
                $id = cmsCore::request('id', 'int', 0);
                $this->inDB->query("UPDATE cms_plugin_imperavi_photos SET i_id= '{$id}' WHERE i_file = '{$match[1]}' LIMIT 1");
            }
        }
        
        return $s.'<textarea class="imperavi_redactor" name="'.$item['name'].'" style="width:'.(is_numeric($item['width']) ? $item['width'].'px' : $item['width']).';height:'.(is_numeric($item['height']) ? $item['height'].'px' : $item['height']).'">'.$item['text'].'</textarea>';

    }
    
    private function canUpload(){
        return $this->config['Enable photo upload for groups'] ? in_array(cmsUser::getInstance()->group_id, explode(',', $this->config['Enable photo upload for groups'])) : false;
    }
    
    private function getRoute($routes) {
        
        if(!cmsCore::inRequest('imperavi'))
            return $routes;

        $add_routes = array(
            array(
                                '_uri'  => '/^content\/_imperavi_photo_uploader_$/i',
                                'do'    => 'imperavi_photo_uploader'
                         ),
            array(
                                '_uri'  => '/^content\/_imperavi_photo_json_$/i',
                                'do'    => 'imperavi_photo_json'
                         )
            );

        return array_merge($add_routes, $routes);

    }

    private function uploadPhoto(){
        
        if(empty($_FILES['file']) && (empty($_POST['contentType']) || empty($_POST['data'])) || !$this->canUpload())
            exit('1');
        
        $good_types = array('image/png','image/jpg','image/gif','image/jpeg','image/pjpeg');
        
        if(!empty($_POST['contentType']) && !empty($_POST['data'])){
            if(!in_array($_POST['contentType'], $good_types))
                exit('2');
            $data = base64_decode($_POST['data']);
            if(!$data)exit('3');
            $file = md5(date('YmdHis')).rand(100,999).'.'.array_pop(explode('/', $_POST['contentType']));
            $path = PATH.'/cache/'.$file;
            file_put_contents($path, $data);
        }else{
            $_FILES['file']['type'] = strtolower($_FILES['file']['type']);
            if(!in_array($_FILES['file']['type'], $good_types))
                exit('4');
            $file = md5(date('YmdHis')).rand(100,999).'.'.array_pop(explode('/', $_FILES['file']['type']));
            $path = PATH.'/cache/'.$file;
            move_uploaded_file($_FILES['file']['tmp_name'], $path);
        }

        $i['i_id'] = cmsCore::request('i_id', 'int', 0);
        $i['i_do'] = cmsCore::request('i_do', 'str', 'do');
        $i['i_comp'] = substr(cmsCore::request('i_comp', 'str', 'comp'), 0, 15);
        $i['user_id'] = cmsUser::getInstance()->id;
        //заливать будем сюда
        $dir = '/images/wysiwyg/'.$i['i_comp'].'/'.date('Y-m');
        cmsCore::includeGraphics();
        
        $i['i_file'] = $dir.'/'.$file;

        if(!$this->isImage($path) || (!is_dir(PATH.$dir) && !mkdir(PATH.$dir, 0777, true)) ||
                !img_resize($path, PATH.$dir.'/'.$file, $this->config['Max img width'], $this->config['Max img height'], false, $this->config['Add watermark'])){
            unlink($path);
            exit('5');
        }

        $this->inDB->insert('cms_plugin_imperavi_photos', $i);
        
        unlink($path);

        cmsCore::jsonOutput(array('filelink' => $i['i_file']), false);

    }
    
    private function getJSON(){
        
        if(!$this->config['Show uploaded photos'])
                        return false;
        
        $return = array();

        $i['i_id'] = cmsCore::request('i_id', 'int', 0);
        $i['i_do'] = cmsCore::request('i_do', 'str', 'do');
        $i['i_comp'] = cmsCore::request('i_comp', 'str', 'comp');
        //$i['user_id'] = cmsUser::getInstance()->id;
        
        if(!$i['i_id'])cmsCore::jsonOutput($return, false);
        
        $files = $this->inDB->get_table('cms_plugin_imperavi_photos', "i_id = '{$i['i_id']}' && i_comp = '{$i['i_comp']}'");// && i_do = '{$i['i_do']}' ($i['i_id'] ? '' : " && user_id = '{$i['user_id']}'")
        
        foreach($files as $file){
            if(file_exists(PATH.$file['i_file'])){
                $return[] = array('image' => $file['i_file'], 'thumb' => $file['i_file']);
            }else{
                $this->inDB->delete('cms_plugin_imperavi_photos', 'id = '.$file['id']);
            }
        }
        
        cmsCore::jsonOutput($return, false);

    }
    
    private function isImage($image_path){
        if (!$f = fopen($image_path, 'rb'))
        {
            return false;
        }
        if ((!$size = getimagesize($image_path)) || $size[0] < 10 || $size[1] < 10)
        {
            return false;
        }

        $data = fread($f, 8);
        fclose($f);

        // signature checking
        $unpacked = unpack("H12", $data);
        if (array_pop($unpacked) == '474946383961' || array_pop($unpacked) == '474946383761') return 'gif';
        $unpacked = unpack("H4", $data);
        if (array_pop($unpacked) == 'ffd8') return 'jpg';
        $unpacked = unpack("H16", $data);
        if (array_pop($unpacked) == '89504e470d0a1a0a') return 'png';

        return false;
    }
    
    private function addHeadJS($path){
        $this->addHead('<script type="text/javascript" src="/'.$path.'"></script>');
    }
    
    private function addHeadCSS($path){
        $this->addHead('<link href="/'.$path.'" rel="stylesheet" type="text/css" />');
    }
    
    private function addHead($tag){
        if(defined('VALID_CMS_ADMIN'))
            $GLOBALS['cp_page_head'][] = $tag;
        else
            $this->inPage->addHead($tag);
    }

}
